package ue018_BMW;
import static org.junit.jupiter.api.Assertions.*;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;


/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
//---------------------------------------------------------------------------------------------------
class _JUT_BMW
{
	private static final String errNewNoError = "NEW: Mit diesen Parametern darf keine Exception ausgelöst werden!";
	private static final String errNewNullPointer  = "NEW: Parameter darf nicht NULL sein (EXCEPTION fehlt): ";;
	private static final String errNewEmptyStr = "NEW: Parameter darf kein Leerstring sein (EXCEPTION fehlt): ";
	private static final String errArgIllegal = "Ungültiger Wert! (EXCEPTION fehlt): ";
	private static final String errArgNoError = "Dieser Wert ist gültig! Hier darf KEINE Exception ausgelöst werden: ";
	private static final String errReturnValue = "Der zurückgegeben Wert ist ungültig! Methode: ";
//	private static final String errReturnListe = "Die zurückgegebene Liste ist noch nicht korrekt! Methode: ";
	private static final String errNoException = "Hier darf keine Exception ausgelöst werden!";
	
	
	// -------------------------------------------------------------------------------------
	@BeforeEach
	void setUp() throws Exception
	{
		  // Hier nicht benötigt
	}


	// -------------------------------------------------------------------------------------
	@Test
	@Order(10)
	void testBMW()
	{
		// ------------------------------------------------------------------------------
		// Teste Konstruktor
		assertThrows(NullPointerException.class, () -> {
			new BMW(null, "Dunkelgrau", 'C', 185);
		}, errNewNullPointer);
		assertThrows(IllegalArgumentException.class, () -> {
			new BMW("", "Dunkelgrau", 'C', 185);
		}, errNewEmptyStr);

		assertThrows(NullPointerException.class, () -> {
			new BMW("X1", null, 'C', 185);
		}, errNewNullPointer);
		assertThrows(IllegalArgumentException.class, () -> {
			new BMW("X1", "", 'C', 185);
		}, errNewEmptyStr);
		assertThrows(IllegalArgumentException.class, () -> {
			new BMW("X1", "Dunkelgrau", 'x', 185);
		}, errArgIllegal + "Bauart");
		assertThrows(IllegalArgumentException.class, () -> {
			new BMW("X1", "Dunkelgrau", 'C', 0);
		}, errArgIllegal + "Leistung");
		assertThrows(IllegalArgumentException.class, () -> {
			new BMW("X1", "Dunkelgrau", 'C', 601);
		}, errArgIllegal + "Leistung");

		// Jetzt sollte alles in Ordnung sein!
		assertDoesNotThrow(() -> {
			new BMW("X1", "Dunkelgrau", 'C', 185);
		}, errNewNoError);
		
		
		// ------------------------------------------------------------------
		BMW x1 = new BMW("X1", "Dunkelgrau", 'C', 185);
		
		assertEquals("X1", 			x1.getTyp(), 		errReturnValue + "getTyp");
		assertEquals("Dunkelgrau",	x1.getFarbe(), 		errReturnValue + "getFarbe");
		assertEquals(185, 			x1.getLeistung(),	errReturnValue + "getLeistung");
		assertEquals('C', 			x1.getBauart(), 	errReturnValue + "getBauart");
		
		
		// ------------------------------------------------------------------
		// Leistung prüfen
		for (int i=-100; i<1000; i++)
		{
			int ps=i;
			if (ps > 0 && ps <=600) 
				assertDoesNotThrow(() -> {
					x1.setLeistung(ps);
				}, errArgNoError + ps);
			else
				assertThrows(IllegalArgumentException.class, () -> {
					x1.setLeistung(ps);
				}, errArgIllegal + ps);
		}
		
		x1.setLeistung(123);
		assertEquals(123, x1.getLeistung(), errReturnValue + 123);
		
		// ------------------------------------------------------------------
		// Farbe prüfen
		assertThrows(NullPointerException.class, () -> {
			x1.setFarbe(null);
		}, errNewNullPointer);
		assertThrows(IllegalArgumentException.class, () -> {
			x1.setFarbe("");
		}, errNewEmptyStr);
		
		x1.setFarbe("Schwarz");
		assertEquals("Schwarz",	x1.getFarbe(), 	errReturnValue + "getFarbe");

		// ------------------------------------------------------------------
		// ohne Bild darf kein Fehler ausgelöst werden
		assertDoesNotThrow(() -> {
			x1.paint();
		}, errNoException);
	}
	// -------- Ende der Klasse 
}
