package ue101_Geraete;

/****************************************************************************************************
 * 
 * Basisklasse für ein Gerät
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Geraet
{
	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN
	String bezeichnung;   // ist hier noch null
	String hersteller;


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR
	public Geraet(String aBezeichnung, String aHersteller)
	{
		// Setter verwenden oder alles aus Setter hier noch einmal programmieren
		setBezeichnung(aBezeichnung);
		setHersteller(aHersteller);
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void print()
	{
		System.out.println("Gerät: " + bezeichnung + " / " + hersteller);
	}


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * Setzen und überprüfen der Bezeichnung des Gerätes
	 *
	 * @param aBezeichnung
	 */
	public void setBezeichnung(String aBezeichnung)
	{
		if (aBezeichnung == null)
			throw new NullPointerException("Bezeichnung darf nicht null sein!");
		
		if (aBezeichnung.equals(""))   // Achtung: String Vergleich mit equals
			throw new IllegalArgumentException("Bezeichnung darf nicht leer sein!");
		
		// alles ist gut
		bezeichnung = aBezeichnung;
	}
	public String getBezeichnung()
	{
		return bezeichnung;
	}

	/**
	 * Setzen und überprüfen des Herstellers des Gerätes
	 *
	 * @param aHersteller
	 */
	public void setHersteller(String aHersteller)
	{
		if (aHersteller == null)
			throw new NullPointerException("Hersteller darf nicht null sein!");

		if (aHersteller.equals(""))   // Achtung: String Vergleich mit equals
			throw new IllegalArgumentException("Bezeichnung darf nicht leer sein!");

		// alles ist gut
		hersteller = aHersteller;
	}
	public String getHersteller()
	{
		return hersteller;
	}


	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Geraet [bezeichnung=%s, hersteller=%s]", bezeichnung, hersteller);
	}

	// -------- Ende der Klasse 
}
