package ue101_Geraete;

/****************************************************************************************************
 * 
 * Notebook erstellen
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Notebook extends Geraet
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String cpu; // Speichert die CPU

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR
	public Notebook(String aBezeichnung, String aHersteller, String aCPU)
	{
		super(aBezeichnung, aHersteller);
		setCpu(aCPU);
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void print()
	{
		super.print();
		System.out.printf("CPU: %s \n", cpu);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the cpu
	 */
	public String getCpu()
	{
		return cpu;
	}
	
	/**
	 * @param aCpu the cpu to set
	 */
	public void setCpu(String aCpu)
	{
		if(aCpu == null)
		{
			throw new NullPointerException("CPU ist leider null");
		}
		if(aCpu.equals(""))
		{
			throw new IllegalArgumentException("CPU darf nicht leer sein!");
		}
		cpu = aCpu;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	
	@Override
	public String toString()
	{
		return String.format("Notebook [cpu=%s]", cpu);
	}

	// -------- Ende der Klasse 
}
