package ue211_Fuhrpark;

import sew.G2D;
import ue111_Fahrzeuge._IFahrzeug;

/****************************************************************************************************
 * 
 * TODO Fahrzeug als super erstellen
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Fahrzeug implements _IFahrzeug
{

	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String fin;
	private String marke;
	private char treibstoff;
	private double vAktuell;
	private String picture;


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Fahrzeug (String aFIN, String aMarke, char aTreibstoff) {
		if (aFIN == null)
			throw new NullPointerException("Fin darf nicht null sein!");
		
		if (aFIN.equals(""))   // Achtung: String Vergleich mit equals
			throw new IllegalArgumentException("Fin darf nicht leer sein!");
		
		
		if (aMarke == null)
			throw new NullPointerException("Marke darf nicht null sein!");
		
		if (aMarke.equals(""))   // Achtung: String Vergleich mit equals
			throw new IllegalArgumentException("Marke darf nicht leer sein!");
		
		aTreibstoff = Character.toUpperCase(aTreibstoff);
		if(aTreibstoff != 'S' && aTreibstoff != 'D') {
			throw new IllegalArgumentException("Traibstoff muss entweder S oder D sein!");
		}
		
		//Alles ist gut!
		fin = aFIN;
		marke = aMarke;
		treibstoff = aTreibstoff;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint()
	{
		if(picture == null)
			G2D.drawString(fin, 400, 400, 100, this);
		else
			G2D.drawImage(picture, 400, 400, this);
	}
	public void paint(int x, int y)
	{
		if(picture == null)
			G2D.drawString(fin, x, y, 100, this);
		else if(picture.equals(""))
			G2D.drawString(fin, x, y, 100, this);
		else
			G2D.drawImage(picture, x, y, this);
	}
	
	@Override
	/**
	 * TODO Beschleudigung des Autos
	 *
	 * @param a		Beschleunigung
	 * @param t		Dauer der Beschleunigung
	 * @return		Geschwindigkeit nacg der Beschleunigung
	 */
	public double beschleunigen(double aA, double aT)
	{
		if(aA < 0) 
			throw new IllegalArgumentException("Ein Auto kann nicht weniger als 0 beschleunigen!");
		if(aT < 0)
			throw new IllegalArgumentException("Dauer muss größer als 0 sein!");
		
		//Alles ist gut
		vAktuell = vAktuell+ aA*aT; //beusleunigung wird ausgerechnet
		if(vAktuell > 108_000_000.0)
			vAktuell = 108_000_000.0; //maximal Licht-Geschwindichkeit
		return vAktuell;
	}
	@Override
	/**
	 *  TODO Bremsen des autos
	 *
	 * @param a		Beschleunigung
	 * @param t		Dauer der Bremsung
	 * @return		Geschwindigkeit nach der Bremsung
	 */
	public double bremsen(double aA, double aT)
	{
		if(aA < 0)
			throw new IllegalArgumentException("Beschleunigung muss größer als 0 sein!");
		if(aT < 0)
			throw new IllegalArgumentException("Dauer muss größer als 0 sein!");
		
		//Alles ist gut
		vAktuell = vAktuell - aA * aT;
		if(vAktuell < 0) {
			vAktuell = 0.0;
		}
		return vAktuell;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @param aPicture the picture to set
	 */
	public void setPicture(String aPicture)
	{
		picture = aPicture;
	}
	/**
	 * @return the picture
	 */
	public String getPicture()
	{
		return picture;
	}
	@Override
	/**
	 * @return the vAktuell
	 */
	public double getvAktuell()
	{
		return vAktuell;
	}
	@Override
	/**
	 * @return the fin
	 */
	public String getFin()
	{
		return fin;
	}
	@Override
	/**
	 * @return the marke
	 */
	public String getMarke()
	{
		return marke;
	}
	@Override
	/**
	 * @return the treibstoff
	 */
	public char getTreibstoff()
	{
		return treibstoff;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Fahrzeug [fin=%s, marke=%s, treibstoff=%s, vAktuell=%s]", fin, marke, treibstoff,
				vAktuell);
	}
	
	// -------- Ende der Klasse 
}
