package ue211_Fuhrpark;

import java.util.ArrayList;
import java.util.Random;

import sew.G2D;
import ue221_Figurenliste.Figur;
import ue221_Figurenliste.Kreis;
import ue221_Figurenliste.Rechteck;

/****************************************************************************************************
 * 
 * TODO Einene Fahrpark erstellen
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Fuhrpark implements _IFuhrpark
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String name;
	private ArrayList<Fahrzeug> fuhrzeug; //referenz zu der Liste
	private String picture;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	Fuhrpark(String name)
	{
		fuhrzeug = new ArrayList<>(); // jetzt könne wir die Liste hinzufügen
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void fahrzeugEinstellen(ue211_Fuhrpark.Fahrzeug aFahrzeug)
	{
		if(aFahrzeug == null)
			throw new NullPointerException("Auto darf nicht null sein!");
		fuhrzeug.add(aFahrzeug);
	}
	
	@Override
	public boolean istFahrzeugEingestellt(ue211_Fuhrpark.Fahrzeug aFahrzeug)
	{
		return fuhrzeug.contains(aFahrzeug);
	}
	
	@Override
	public void fahrzeugEntfernen(ue211_Fuhrpark.Fahrzeug aFahrzeug)
	{
		fuhrzeug.remove(aFahrzeug);
	}
	
	@Override
	public void printFahrzeugListe()
	{
		for(Fahrzeug fahrzeug : fuhrzeug)
		{
			System.out.printf("%s \n", fahrzeug.toString());
		}
	}
	
	@Override
	public void printAutoListe()
	{
		for(Fahrzeug fahrzeug : fuhrzeug)
		{
			if(fahrzeug instanceof Auto)
				System.out.printf("%s \n", fahrzeug.toString());
		}
	}
	
	public void paintAlleFahrzeuge()
	{
		Random rand = new Random(); 
	      // Setting the upper bound to generate the
	      // random numbers in specific range
	      int upperbound = 400;
	      
		for(Fahrzeug fahrzeug : fuhrzeug)
		{
			fahrzeug.paint(rand.nextInt(upperbound), rand.nextInt(upperbound));
		}
	}
	

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public void setName(String aName)
	{
		if(aName == null)
			throw new NullPointerException("Name darf nicht NULL sein!!!");
		name = aName;
	}
	@Override
	public String getName()
	{
		return name;
	}
	@Override
	public int getAnzAutos()
	{
		int count = 0;
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof Auto)
				count++;
		}
		
		return count;
	}
	@Override
	public int getAnzCabrios()
	{
		int count = 0;
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof Cabrio)
				count++;
		}
		
		return count;
	}
	@Override
	public int getAnzLKWs()
	{
		int count = 0;
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof LKW)
				count++;
		}
		
		return count;
	}
	@Override
	public int getAnzMotorrad()
	{
		int count = 0;
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof Motorrad)
				count++;
		}
		
		return count;
	}
	@Override
	public int getAnzMopedUndMotorrad()
	{
		int count = 0;
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof Moped || fahrzeug instanceof Motorrad)
				count++;
		}
		
		return count;
	}
	@Override
	public ArrayList<Auto> getAutos()
	{
		ArrayList<Auto> list = new ArrayList<>();
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof Auto)
				list.add((Auto) fahrzeug);
		}
		
		return list;
	}
	@Override
	public ArrayList<Cabrio> getCabrios()
	{
		ArrayList<Cabrio> list = new ArrayList<>();
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof Cabrio)
				list.add((Cabrio) fahrzeug);
		}
		
		return list;
	}
	@Override
	public ArrayList<LKW> getLKWs()
	{
		ArrayList<LKW> list = new ArrayList<>();
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof LKW)
				list.add((LKW) fahrzeug);
		}
		
		return list;
	}
	@Override
	public ArrayList<Motorrad> getMotorraeder()
	{
		ArrayList<Motorrad> list = new ArrayList<>();
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof Motorrad)
				list.add((Motorrad) fahrzeug);
		}
		
		return list;
	}
	@Override
	public ArrayList<Fahrzeug> getAutosUndCabrios(char aBauart)
	{
		ArrayList<Fahrzeug> list = new ArrayList<>();
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug instanceof Auto)
				if(((Auto) fahrzeug).getBauart() == aBauart)
					list.add((Fahrzeug) fahrzeug);
			
			if(fahrzeug instanceof Cabrio)
				if(((Cabrio) fahrzeug).getBauart() == aBauart)
					list.add((Fahrzeug) fahrzeug);
		}
		
		return list;
	}
	@Override
	public Fahrzeug getFahrzeugMitFIN(String aFIN)
	{
		for(Fahrzeug fahrzeug: fuhrzeug)
		{
			if(fahrzeug.getFin() == aFIN)
				return fahrzeug;
				
		}
		return null;
	}


	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format(
				"Fuhrpark [name=%s, fuhrzeug=%s, getName()=%s, getAnzAutos()=%s, getAnzCabrios()=%s, getAnzLKWs()=%s, getAnzMotorrad()=%s, getAnzMopedUndMotorrad()=%s, getAutos()=%s, getCabrios()=%s, getLKWs()=%s, getMotorraeder()=%s]",
				name, fuhrzeug, getName(), getAnzAutos(), getAnzCabrios(), getAnzLKWs(), getAnzMotorrad(),
				getAnzMopedUndMotorrad(), getAutos(), getCabrios(), getLKWs(), getMotorraeder());
	}

	// -------- Ende der Klasse 
}
