package ue211_Fuhrpark;

import java.util.ArrayList;


/****************************************************************************************************
 * 
 * Implemetiere das gegebene Interface als Klasse
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _IFuhrpark
{

	void setName(String aName);

	String getName();

	/** --------------------------------------------------------------------------------<br>
	 * Ein neues Fahrzeug wird in dem Fuhrpark hinzugefügt (eingestellt)
	 * 
	 * @param aFahrzeug		Referenz auf das Fahrzeug, welches hinzugefügt werden soll
	 */
	void fahrzeugEinstellen(Fahrzeug aFahrzeug);

	/** --------------------------------------------------------------------------------<br>
	 * Prüft, ob ein Fahrzeug im Fuhrpark bereits vorhanden ist.
	 * 
	 * @param aFahrzeug		Referenz auf das Fahrzeug, welches gesucht werden soll
	 * @return				true, falls im Fuhrpark gefunden
	 */
	boolean istFahrzeugEingestellt(Fahrzeug aFahrzeug);

	/** --------------------------------------------------------------------------------<br>
	 * Wenn ein Fahrzeuge verkauft wird, muss es aus dem Fuhrpark entfernt werden.
	 * 
	 * @param aFahrzeug		Referenz auf das Fahrzeug, welches entfernt werden soll
	 */
	void fahrzeugEntfernen(Fahrzeug aFahrzeug);

	/** --------------------------------------------------------------------------------<br>
	 * Alle Fahrzeuge als Liste in der Konsole ausgeben
	 */
	void printFahrzeugListe();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Autos in der Konsole ausgeben
	 */
	void printAutoListe();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl der Fahrzeuge einer bestimmten Art.
	 * Tipp: instanceof!
	 * 
	 * @return  Anzahl der Fahrzeuge einer bestimmten Art
	 */
	int getAnzAutos();

	int getAnzCabrios();

	int getAnzLKWs();

	int getAnzMotorrad();

	int getAnzMopedUndMotorrad();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Autos im Fuhrpark
	 * 
	 * @return	Liste aller Autos
	 */
	ArrayList<Auto> getAutos();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Cabrios im Fuhrpark
	 * 
	 * @return	Liste aller Cabrios
	 */
	ArrayList<Cabrio> getCabrios();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller LKWs im Fuhrpark
	 * 
	 * @return	Liste aller LKWs
	 */
	ArrayList<LKW> getLKWs();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Motorräder im Fuhrpark
	 * 
	 * @return	Liste aller Motorräder
	 */
	ArrayList<Motorrad> getMotorraeder();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Autos und Cabrios einer bestimmten Bauart
	 * 
	 * @return	Liste aller Autos und Cabrios einer bestimmten Bauart
	 */
	ArrayList<Fahrzeug> getAutosUndCabrios(char aBauart);

	/** --------------------------------------------------------------------------------<br>
	 * Sucht das Fahrzeug mit einer bestimmten FIN.
	 * 
	 * @param aFIN		FIN, des gesuchten Fahrzeuges
	 * @return			gesuchtes Fahrzeug oder null falls nicht gefunden
	 */
	Fahrzeug getFahrzeugMitFIN(String aFIN);

	String toString();

}