package ue211_Fuhrpark;

import sew.G2D;

/****************************************************************************************************
 * 
 * Main Programm für den Fuhrpark
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */


//---------------------------------------------------------------------------------------------------
public class _Main_FuhrparkSuS
{
	// -------------------------------------------------------------------------------------
	public static void main(String[] args)
	{
		Fuhrpark      htl   = new Fuhrpark("HTLTraun");
		
		htl.fahrzeugEinstellen(new Auto("AUT-1001", "BMW X1", 'S', 'L'));
		htl.fahrzeugEinstellen(new Cabrio("CAB-2001", "Audi", 'S', 'C'));
		htl.fahrzeugEinstellen(new LKW("LKW-4001", "MAN", 'D', 15000 ));
		htl.fahrzeugEinstellen(new Cabrio("CAB-2003", "Audi", 'D', 'K'));
		htl.fahrzeugEinstellen(new Motorrad("MOT-3001", "KTM", 'S', 3));
		htl.fahrzeugEinstellen(new Auto("AUT-1002", "BMW X3", 'S', 'L'));
		htl.fahrzeugEinstellen(new LKW("LKW-4002", "MAN", 'D', 25000));
		htl.fahrzeugEinstellen(new Moped("MOP-5001", "Puch Stangl", 'S'));
		htl.fahrzeugEinstellen(new Moped("MOP-5002", "Vespa Viagio", 'S'));
		htl.fahrzeugEinstellen(new Cabrio("CAP-2002", "Mercedes", 'S', 'C'));
		
		//-------------------------------------------------------------------------------------
		//Bilder Aller Fahrzeuge ausgeben
		G2D.setVisible();
		htl.getFahrzeugMitFIN("AUT-1001").setPicture("src/_Images/Fahzeug/Auto.png");
		htl.getFahrzeugMitFIN("CAB-2001").setPicture("/src/_Images/Fahzeug/Cabrio.png");
		htl.getFahrzeugMitFIN("LKW-4001").setPicture("src/_Images/Fahzeug/LKW.png");
		htl.getFahrzeugMitFIN("MOT-3001").setPicture("src/_Images/Fahzeug/Motorrad.png");
		htl.getFahrzeugMitFIN("MOP-5001").setPicture("src/_Images/Fahzeug/Mopped.png");
		htl.paintAlleFahrzeuge();

		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller Fahrzeuge\n");		
		htl.printFahrzeugListe();
		

		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> ANZAHL der Autos, Cabrios, LKWs, Motorrad, Moped+Motorrad ... \n");		
		System.out.printf("Anzahl Autos: %17s %n", htl.getAnzAutos());
		System.out.printf("Anzahl Cabrios: %15s %n", htl.getAnzCabrios());
		System.out.printf("Anzahl LKWs: %18s %n", htl.getAnzLKWs());
		System.out.printf("Anzahl Motorrad: %14s %n", htl.getAnzMotorrad());
		System.out.printf("Anzahl Moped und Motorrad: %4s %n", htl.getAnzMopedUndMotorrad());

		
		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller AUTOS\n");		
		htl.printAutoListe();

		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller CABRIOS\n");		
		for(Fahrzeug fahrzeug : htl.getCabrios())
		{
			System.out.printf("%s \n", fahrzeug.toString());
		}

		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller LKWs\n");		
		for(Fahrzeug fahrzeug : htl.getLKWs())
		{
			System.out.printf("%s \n", fahrzeug.toString());
		}

		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller Motorräder\n");		
		for(Fahrzeug fahrzeug : htl.getMotorraeder())
		{
			System.out.printf("%s \n", fahrzeug.toString());
		}

		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller Autos und Cabrios der Bauart 'C'oupe\n");		
		for(Fahrzeug fahrzeug : htl.getAutosUndCabrios('C'))
		{
			System.out.printf("%s \n", fahrzeug.toString());
		}


		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Finde das Fahrzeug mit einer der FIN:\n"
				+ "\t LKW-4001\n" 
				+ "\t CAB-2001\n"
				+ "\t MOP-5002\n"
				+ "\t AUT-4711\n"
				);		
		System.out.printf("Fahrzeug: %s \n", htl.getFahrzeugMitFIN("LKW-4001").toString());
		System.out.printf("Fahrzeug: %s \n", htl.getFahrzeugMitFIN("CAB-2001").toString());
		System.out.printf("Fahrzeug: %s \n", htl.getFahrzeugMitFIN("MOP-5002").toString());
		System.out.printf("Fahrzeug: %s \n", htl.getFahrzeugMitFIN("AUT-4711").toString());
		
	}
}
