package ue221_Figurenliste;

import java.util.ArrayList;


/****************************************************************************************************
 * 
 * Implementiere alle Methoden dieses Interfaces
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _IFigurenListe
{

	/** --------------------------------------------------------------------------------<br>
	 * Eine neue Figur am Ende der Liste hinzufügen.
	 * 
	 * @param aFigur	Referenz auf die Figur, welche hinzugefügt werden soll
	 */
	void neueFigurHinzufuegen(Figur aFigur);

	/** --------------------------------------------------------------------------------<br>
	 * Prüft, ob ein Figur bereits in der Liste eingetragen (vorhanden) ist.
	 * 
	 * @param aFigur	Referenz auf die Figur, welche gesucht werden soll
	 * @return			true, falls in der Liste gefunden
	 */
	boolean istFigurBereitsInDerListe(Figur aFigur);

	/** --------------------------------------------------------------------------------<br>
	 * Entfernt eine Figur aus der Liste.
	 * 
	 * @param aFigur	Referenz auf die Figur, welche entfernt werden soll
	 */
	void entferneFigurAusDerListe(Figur aFigur);

	/** --------------------------------------------------------------------------------<br>
	 * Alle Figuren als Liste in der Konsole ausgeben
	 */
	void printFigurenListe();

	/** --------------------------------------------------------------------------------<br>
	 * Nur alle Kreise als Liste in der Konsole ausgeben
	 * Tipp: instanceof!
	 */
	void printKreisListe();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Figuren in der Liste mit paint zeichnen
	 */
	void alleFigurenZeichnen();

	/** --------------------------------------------------------------------------------<br>
	 * Nur alle Rechtecke mit paint zeichnen
	 * Tipp: instanceof!
	 */
	void alleRechteckeZeichnen();

	/** --------------------------------------------------------------------------------<br>
	 * Nur alle Quadrate mit paint zeichnen
	 * Tipp: instanceof!
	 */
	void alleQuadrateZeichnen();

	/** --------------------------------------------------------------------------------<br>
	 * Nur alle Kreise mit paint zeichnen
	 * Tipp: instanceof!
	 */
	void alleKreiseZeichnen();

	/** --------------------------------------------------------------------------------<br>
	 * Setzt alle Figuren auf eine zufällige Position und zeichnet danach wieder 
	 * alle Figuren neu
	 */
	void alleFigurenAufZufaelligePosition();

	/** --------------------------------------------------------------------------------<br>
	 * Setzt alle Kreise auf eine zufällige Position und zeichnet danach wieder 
	 * alle Figuren neu
	 */
	void alleKreiseAufZufaelligePosition();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Rechtecke mit einer zufälligen neuen Farbe füllen 
	 */
	void alleRechteckeZufaelligeFaerben();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl aller Kreise
	 * Tipp: instanceof!
	 * 
	 * @return  Anzahl der Kreise
	 */
	int getAnzKreis();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl aller Rechtecke
	 * Tipp: instanceof!
	 * 
	 * @return  Anzahl der Rechtecke
	 */
	int getAnzRechteck();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl aller Quadrate
	 * Tipp: instanceof!
	 * 
	 * @return  Anzahl der Quadrate
	 */
	int getAnzQuadrat();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl aller Rechtecke und Quadrate
	 * Tipp: instanceof!
	 * 
	 * @return  Anzahl der Rechtecke und Quadrate
	 */
	int getAnzRechteckUndQuadrat();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl aller Kreise deren Radius größer als der übergebene ist. 
	 * Tipp: instanceof!
	 * 
	 * @return  Anzahl der Figuren
	 */
	int getAnzKreisGroesserAls(int aRadius);

	/** --------------------------------------------------------------------------------<br>
	 * Erstelle eine Liste mit allen Rechtecke in der Liste
	 * 
	 * @return	Liste aller Rechtecke
	 */
	ArrayList<Rechteck> getRechtecke();

	/** --------------------------------------------------------------------------------<br>
	 * Erstelle eine Liste mit allen Quadrate in der Liste
	 * 
	 * @return	Liste aller Quadrate
	 */
	ArrayList<Quadrat> getQuadrate();

	/** --------------------------------------------------------------------------------<br>
	 * Erstelle eine Liste mit allen Kreise in der Liste
	 * 
	 * @return	Liste aller Kreise
	 */
	ArrayList<Kreis> getKreise();

	/** --------------------------------------------------------------------------------<br>
	 * Erstelle eine Liste mit allen Quadrate mit einer Seitenlänge größer als 
	 * der gegebene
	 * 
	 * @return	Liste aller Quadrate
	 */
	ArrayList<Quadrat> getQuadrateGroesserAls(int aSeitenlaenge);

}