package ue231_Zoo;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO Wildtiere Superklase
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Wildtier implements _IWildtier
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	String id;
	String art;
	int alter;
	private int x;
	private int y;
	private String picture;
	

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Wildtier(String aId, String aArt, int aAlter)
	{
		if(aId == null)
			throw new NullPointerException("Id darf nicht NULL sein");
		if(aId.equals(""))
			throw new IllegalArgumentException("Id darf nicht Leer sein");
		
		if(aArt == null)
			throw new NullPointerException("Art darf nicht NULL sein");
		if(aArt.equals(""))
			throw new IllegalArgumentException("Art darf nicht Leer sein");
		//Alles gut!
		id    = aId;
		art   = aArt;
		setAlter(aAlter);
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public abstract void bewegeDich();
	public abstract void gibLaut();
	public abstract void frissEtwas();
	
	public void paint()
	{
		if(picture == null)
			G2D.drawString(id, 400, 400, 100, this);
		else
			G2D.drawImage(picture, 400, 400, this);
	}

	public void paint(int aX, int aY)
	{
		setX(aX);
		setY(aY);
		if(picture == null)
			G2D.drawString(id, getX(), getY(), 100, this);
		else if(picture.equals(""))
			G2D.drawString(id, getX(), getY(), 100, this);
		else
			G2D.drawImage(picture, getX(), getY(), this);
	}
	
	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}
	/**
	 * @return the art
	 */
	public String getArt()
	{
		return art;
	}

	/**
	 * @return the alter
	 */
	public int getAlter()
	{
		return alter;
	}
	/**
	 * @param aAlter the alter to set
	 */
	public void setAlter(int aAlter)
	{
		if(aAlter < 0)
			throw new IllegalArgumentException("Ein tier kann nicth jonger als 0 Jahren sein");
		alter = aAlter;
	}
	
	public int getX()
	{
		return x;
	}
	public void setX(int aX)
	{
		x = aX;
	}


	public int getY()
	{
		return y;
	}
	public void setY(int aY)
	{
		y = aY;
	}

	/**
	 * @param aPicture the picture to set
	 */
	public void setPicture(String aPicture)
	{
		picture = aPicture;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Wildtier [id=%s, art=%s, alter=%s]", id, art, alter);
	}

	// -------- Ende der Klasse 
}
