package ue231_Zoo;

import java.util.ArrayList;


/****************************************************************************************************
 * 
 * TODO
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _IZoo
{

	/** --------------------------------------------------------------------------------<br>
	 * Ein neues Tier wird in dem Zoo hinzugefügt (Geboren, freigelassen, etc.)
	 * 
	 * @param aTier
	 */
	void neuesTierAufnehmen(Wildtier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Prüft, ob ein Tier im Zoo bereits vorhanden ist.
	 * 
	 * @param aTier
	 * @return		true, falls im Zoo gefunden
	 */
	boolean istTierImZoo(Wildtier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Wenn ein Tier freigelassen wird, muss es aus dem Zoo entfernt werden.
	 * 
	 * @param aTier
	 */
	void tierEntlassen(Wildtier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Tiere in der Konsole ausgeben
	 */
	void printTierListe();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Löwen in der Konsole ausgeben
	 */
	void printLoewenListe();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Tiere im Zoo füttern
	 */
	void alleTiereFuettern();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Tiere im Zoo bewegen
	 */
	void alleTiereBewegen();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Löwen brüllen lassen
	 * 
	 */
	void alleLoewenBruellen();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Elefanten sich im Schlamm wälzen lassen
	 * 
	 */
	void alleElefantenWaelzenSich();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Gorillas auf den Baum klettern lassen
	 * 
	 */
	void alleGorillasKletternAufDenBaum();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl der Tiere einer bestimmten Gattung.
	 * 
	 * @return  Anzahl der Tiere einer bestimmten Gattung
	 */
	int getAnzLoewen();

	int getAnzElefanten();

	int getAnzGazellen();

	int getAnzGepard();

	int getAnzGorilla();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Löwen im Zoo
	 * 
	 * @return	Liste aller Löwen
	 */
	ArrayList<Loewe> getLoewen();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Elefanten im Zoo
	 * 
	 * @return	Liste aller Elefanten
	 */
	ArrayList<Elefant> getElefanten();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Gazellen im Zoo
	 * 
	 * @return	Liste aller Gazellen
	 */
	ArrayList<Gazelle> getGazellen();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Geparden im Zoo
	 * 
	 * @return	Liste aller Geparden
	 */
	ArrayList<Gepard> getGepard();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Gorillas im Zoo
	 * 
	 * @return	Liste aller Gorillas
	 */
	ArrayList<Gorilla> getGorilla();

	/** --------------------------------------------------------------------------------<br>
	 * Sucht das Tier mit einer bestimmten ID.
	 * 
	 * @param aId		ID, des gesuchten Tieres
	 * @return			gesuchtes Wildtier oder null falls nicht gefunden
	 */
	Wildtier getTier(String aId);

}