package ue241_HerrDerRinge;

import java.util.ArrayList;
import java.util.Random;

import ue231_Zoo.Loewe;
import ue231_Zoo.Wildtier;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class FilmFiguren implements _IFilmFiguren
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private ArrayList<Wesen> listeDerWesen;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public FilmFiguren()
	{
		listeDerWesen = new ArrayList<Wesen>();
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void neueSpielfigur(Wesen aWesen)
	{
		listeDerWesen.add(aWesen);
	}

	@Override
	public boolean istInDerListe(Wesen aWesen)
	{
		return listeDerWesen.contains(aWesen);
	}

	@Override
	public void entferne(Wesen aWesen)
	{
		listeDerWesen.remove(aWesen);
	}

	@Override
	public void printAlleFiguren()
	{
		for(Wesen figur : listeDerWesen)
		{
			System.out.printf("%s \n", figur.toString());
		}
	}

	@Override
	public void printHobbitListe()
	{
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Hobbit)
				figur.toString();
		}
	}

	@Override
	public void paintAlleFigurenRandom()
	{
		for(Wesen figur : listeDerWesen)
		{
			figur.paintRandonm();
		}
	}

	@Override
	public void moveAlleFigurenRandom()
	{
		Random rand = new Random(); 
	    int upperbound = 800;
	    
	    for(Wesen figur : listeDerWesen)
		{
			figur.moveTo(rand.nextInt(upperbound), rand.nextInt(upperbound), 10);
		}
	}

	@Override
	public void alleFigurenLaufen()
	{
		for(Wesen figur : listeDerWesen)
		{
			figur.laufen();
		}
	}

	@Override
	public void alleFigurenKaempfen()
	{
		for(Wesen figur : listeDerWesen)
		{
			figur.kaempfen();
		}
	}

	@Override
	public void mitHobbitsVersteckenSich()
	{
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Hobbit)
				((Hobbit) figur).verstecken();
		}
	}

	@Override
	public void alleZaubererZaubern()
	{
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Zauberer)
				((Zauberer) figur).zaubern();
		}
	}

	@Override
	public void alleOrksStreiten()
	{
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Ork)
				((Ork) figur).streiten();
		}
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	@Override
	public int getAnzOrks()
	{
		int count = 0;
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Ork)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzZwergeUndHobbits()
	{
		int count = 0;
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Hobbit || figur instanceof Zwerg)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzFigurenOhneOrks()
	{
		int count = 0;
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Ork)
			{
				//Nicht ausführen
				count +=1;
				count -=1;
			}
			else
				count++;
		}
		return count;
	}

	@Override
	public ArrayList<Zauberer> getZauberer()
	{
		ArrayList<Zauberer> zauberer = new ArrayList<Zauberer>();
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Zauberer)
				zauberer.add((Zauberer) figur);
		}
		return zauberer;
	}

	@Override
	public ArrayList<Hobbit> getHobbits()
	{
		ArrayList<Hobbit> hobbits = new ArrayList<Hobbit>();
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Hobbit)
				hobbits.add((Hobbit) figur);
		}
		return hobbits;
	}

	@Override
	public ArrayList<Ork> getOrks()
	{
		ArrayList<Ork> orks = new ArrayList<Ork>();
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Ork)
				orks.add((Ork) figur);
		}
		return orks;
	}

	@Override
	public Wesen getWesen(String aName)
	{
		for(Wesen figur : listeDerWesen)
		{
			if(aName.isEmpty())
				throw new NullPointerException("Name darf nicht NULL sein!");
			if(figur.getName().equals(aName))
				return figur;
		}
		return null;
	}

	@Override
	public ArrayList<Wesen> getGutWesenMitMindestStaerke(int aStaerke)
	{
		ArrayList<Wesen> gutWesenMItMindSt = new ArrayList<Wesen>();
		for(Wesen figur : listeDerWesen)
		{
			if(figur instanceof Ork)
			{
				//Nichts machen
				gutWesenMItMindSt.add(figur);
				gutWesenMItMindSt.remove(figur);
			}
			else if(figur.getStaerke() >= aStaerke)
				gutWesenMItMindSt.add(figur);
		}
		return gutWesenMItMindSt;
	}

	@Override
	public ArrayList<Wesen> getWesenDieFreundeSind()
	{
		ArrayList<Wesen> freundwesen = new ArrayList<Wesen>();
		for(Wesen figur : listeDerWesen)
		{
			if(figur.getFreundVon() != null)
				freundwesen.add(figur.getFreundVon());
		}
		
		return freundwesen;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse 
}
