package ue241_HerrDerRinge;
import static org.junit.jupiter.api.Assertions.*;

import java.util.ArrayList;
import java.util.List;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;

/****************************************************************************************************
 * 
 * JUnit Test für Klasse Figurenliste.
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */


//@TestMethodOrder(MethodOrderer.OrderAnnotation.Alphanumeric.class)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
//---------------------------------------------------------------------------------------------------
class _JUT_FilmFiguren
{
//	private static final String errNewNoError = "NEW: Mit diesen Parametern darf keine Exception ausgelöst werden!";
//	private static final String errNewNullPointer  = "NEW: Parameter darf nicht NULL sein (EXCEPTION fehlt): ";;
//	private static final String errNewEmptyStr = "NEW: Parameter darf kein Leerstring sein (EXCEPTION fehlt): ";
//	private static final String errArgIllegal = "Ungültiger Wert! (EXCEPTION fehlt): ";
//	private static final String errArgNoError = "Dieser Wert ist gültig! Hier darf KEINE Exception ausgelöst werden: ";
	private static final String errReturnValue = "Der zurückgegeben Wert ist ungültig! Methode: ";
	private static final String errReturnListe = "Die zurückgegebene Liste ist noch nicht korrekt! Methode: ";
	private static final String errNoException = "Hier darf keine Exception ausgelöst werden!";

	// -----------------------------------------------------------------
	// Variablen für Testumgebung
	FilmFiguren     testListe;

	Hobbit      hob1, hob2;
	Elfe        elf1, elf2;
	Ork         ork1, ork2;
	Zauberer    zau1, zau2;
	Zwerg       zwe1;

	// -----------------------------------------------------------------------------------
	@BeforeEach
	void setUp() throws Exception
	{
		testListe = new FilmFiguren();

		// Die einzelnen Klassen wurden bereits in einem anderen JUnit-Test getestet
		hob1    = new Hobbit("HOB01", 111,"a", 120);
		hob2    = new Hobbit("HOB02", 222,"a", 220);;
		zau1    = new Zauberer("ZAU01", 111,"a", "Der Erste");
		zau2    = new Zauberer("ZAU02", 222,"a", "Der Zweite");
		elf1    = new Elfe("ELF01", 111,"a", 120);
		elf2    = new Elfe("ELF02", 222,"a", 220);
		ork1    = new Ork("ORK01", 111,"a", "Erster");
		ork2    = new Ork("ORK02", 222,"a", "Zweiter");
		zwe1    = new Zwerg("ZWE01", 111,"a", 110);

		zau1.setFreundVon(hob1);
		elf1.setFreundVon(hob1);
		
		testListe.neueSpielfigur(hob1);
		testListe.neueSpielfigur(hob2);
		testListe.neueSpielfigur(elf1);
		testListe.neueSpielfigur(elf2);
		testListe.neueSpielfigur(ork1);
		testListe.neueSpielfigur(ork2);
		testListe.neueSpielfigur(zau1);
		testListe.neueSpielfigur(zau2);
		testListe.neueSpielfigur(zwe1);
	}


	// -----------------------------------------------------------------------------------
	@Test
	@Order(21)
	void testNeueSpielfigur()
	{
		assertTrue(testListe.istInDerListe(zwe1), errReturnValue + "istInDerListe");

		Zauberer neu = new Zauberer("ZAUTEST", 999,"a", "Test");
		assertFalse(testListe.istInDerListe(neu), errReturnValue + "istInDerListe");

		testListe.neueSpielfigur(neu);
		assertTrue(testListe.istInDerListe(neu), errReturnValue + "istInDerListe");
	}


	@Test
	@Order(22)
	void testFigurEntfernen()
	{
		assertTrue(testListe.istInDerListe(zau2), errReturnValue + "istInDerListe");
		testListe.entferne(zau2);
		assertFalse(testListe.istInDerListe(zau2), errReturnValue + "istInDerListe");
	}

	@Test
	void testPrintListe()
	{
		assertDoesNotThrow(() -> {
			testListe.printAlleFiguren();
			testListe.printHobbitListe();
		}, errNoException );
	}

	@Test
	void testAlleMethodenTesten()
	{
		assertDoesNotThrow(() -> {
			testListe.alleFigurenKaempfen();
			testListe.alleFigurenLaufen();
			testListe.alleOrksStreiten();
			testListe.alleZaubererZaubern();
		}, errNoException );
	}

	@Test
	void testGetAnzahlTesten()
	{
		assertEquals(2,testListe.getAnzOrks(), 				errReturnValue + "getAnzOrks");
		assertEquals(7,testListe.getAnzFigurenOhneOrks(), 	errReturnValue + "getAnzFigurenOhneOrks");
		assertEquals(3,testListe.getAnzZwergeUndHobbits(),	errReturnValue + "getAnzZwergeUndHobbits");
	}


	@Test
	void testGetHobbits()
	{
		// ----------------------------------------------
		List<Wesen> v = new ArrayList<>();
		v.add(hob1);
		v.add(hob2);
		assertEquals(v, testListe.getHobbits(), errReturnListe + "getHobbits");
	}

	@Test
	void testGetOrks()
	{
		// ----------------------------------------------
		List<Wesen> v = new ArrayList<>();
		v.add(ork1);
		v.add(ork2);
		assertEquals(v, testListe.getOrks(), errReturnListe + "getOrks");
	}

	@Test
	void testGetZauberer()
	{
		// ----------------------------------------------
		List<Wesen> v = new ArrayList<>();
		v.add(zau1);
		v.add(zau2);
		assertEquals(v, testListe.getZauberer(), errReturnListe + "getZauberer");
	}

	@Test
	void testGetWesenDieFreundeSind()
	{
		// ----------------------------------------------
		List<Wesen> v = new ArrayList<>();
		v.add(hob1);
//		v.add(hob1);  // Hob2 darf nur einmal in der Liste vorkommen!!!
		assertEquals(v, testListe.getWesenDieFreundeSind(), errReturnListe + "getWesenDieFreundeSind");
	}


	@Test
	void testGetGutWesenMitMindestStaerke()
	{
		// ----------------------------------------------
		List<Wesen> v = new ArrayList<>();
		v.add(hob2);
		v.add(elf2);
		v.add(zau2);
		assertEquals(v, testListe.getGutWesenMitMindestStaerke(200), errReturnListe + "getGutWesenMitMindestStaerke");
	}

	@Test
	void testGetWesen()
	{
		assertEquals(elf1, testListe.getWesen("ELF01"), errReturnValue + "getWesen");
		assertEquals(null, testListe.getWesen("TEST"), errReturnValue + "getWesen");
	}
}
