package ue322_Steuerung;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Fahrzeug
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String bezeichnung;
	private double maxGeschwindigkeit;
	private double maxBeschleunigung;
	private double maxVerzoegerung;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Fahrzeug(String aBezeichnung, double aMaxGeschwindigkeit, double aMaxBeschleunigung, double aMaxVerzoegerung)
	{
		if(aBezeichnung == null) // Überprüft dass es nicht null ist oder Leer
			throw new NullPointerException("Bezeichnung darf nicht NULL sein");
		if(aBezeichnung.isEmpty())
			throw new IllegalArgumentException("Bezeichnung darf nicht Leer sein");
		
		//Alles okay
		bezeichnung = aBezeichnung;
		
		//Im stter wird es auch Überprüft
		setMaxGeschwindigkeit(aMaxGeschwindigkeit);
		setMaxBeschleunigung(aMaxBeschleunigung);
		setMaxVerzoegerung(aMaxVerzoegerung);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the bezeichnung
	 */
	public String getMarke()
	{
		return bezeichnung;
	}

	/**
	 * @return the maxGeschwindigkeit
	 */
	public double getMaxGeschwindigkeit()
	{
		return maxGeschwindigkeit;
	}

	/**
	 * @param aMaxGeschwindigkeit the maxGeschwindigkeit to set
	 */
	public void setMaxGeschwindigkeit(double aMaxGeschwindigkeit)
	{
		if(aMaxGeschwindigkeit <= 0)
			throw new IllegalArgumentException("MaxGeschwindigkeit muss groeßer als 0 sein!");
		maxGeschwindigkeit = aMaxGeschwindigkeit;
	}

	/**
	 * @return the maxBeschleunigung
	 */
	public double getMaxBeschleunigung()
	{
		return maxBeschleunigung;
	}

	/**
	 * @param aMaxBeschleunigung the maxBeschleunigung to set
	 */
	public void setMaxBeschleunigung(double aMaxBeschleunigung)
	{
		if(aMaxBeschleunigung <= 0)
			throw new IllegalArgumentException("MaxBeschleunigung muss groeßer als 0 sein!");
		maxBeschleunigung = aMaxBeschleunigung;
	}

	/**
	 * @return the maxVerzoegerung
	 */
	public double getMaxVerzoegerung()
	{
		return maxVerzoegerung;
	}

	/**
	 * @param aMaxVerzoegerung the maxVerzoegerung to set
	 */
	public void setMaxVerzoegerung(double aMaxVerzoegerung)
	{
		if(aMaxVerzoegerung <= 0)
			throw new IllegalArgumentException("MaxVerzoegerung muss groeßer als 0 sein!");
		maxVerzoegerung = aMaxVerzoegerung;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format(
				"Fahrzeug [bezeichnung=%s, maxGeschwindigkeit=%s, maxBeschleunigung=%s, maxVerzoegerung=%s]",
				bezeichnung, maxGeschwindigkeit, maxBeschleunigung, maxVerzoegerung);
	}

	// -------- Ende der Klasse 
}
